Package org.codehaus.groovy.groovydoc

# Interface GroovyRootDoc

All Superinterfaces:
  `Comparable<GroovyDoc>`, `GroovyDoc`, `GroovyDocErrorReporter`

All Known Implementing Classes:
  `SimpleGroovyRootDoc`

public interface GroovyRootDoc extends GroovyDoc, GroovyDocErrorReporter
Root object for a Groovydoc run, exposing the discovered packages, classes, and diagnostics APIs.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `GroovyClassDoc[]`
  `classes()`
  Returns all classes known to this documentation run.
  `GroovyClassDoc`
  `classNamed(GroovyClassDoc groovyClassDoc, String name)`
  Resolves a class name from the perspective of another documented class.
  `Map<String,GroovyClassDoc>`
  `getResolvedClasses()`
  Returns the classes that have already been resolved for the current documentation run.
  `Map<String,GroovyClassDoc>`
  `getVisibleClasses(List importedClassesAndPackages)`
  Returns the classes visible from a set of imports.
  `String[][]`
  `options()`
  Returns the effective tool options associated with this documentation run.
  `GroovyPackageDoc`
  `packageNamed(String arg0)`
  Resolves a package by name.
  `GroovyClassDoc[]`
  `specifiedClasses()`
  Returns the classes explicitly specified as documentation targets.
  `GroovyPackageDoc[]`
  `specifiedPackages()`
  Returns the packages explicitly specified as documentation targets.

  ### Methods inherited from interface java.lang.Comparable

  `compareTo`

  ### Methods inherited from interface org.codehaus.groovy.groovydoc.GroovyDoc

  `commentText, firstSentenceCommentText, getRawCommentText, isAnnotationType, isAnnotationTypeElement, isClass, isConstructor, isDeprecated, isEnum, isEnumConstant, isError, isException, isField, isIncluded, isInterface, isMethod, isOrdinaryClass, isRecord, name, setRawCommentText`

  ### Methods inherited from interface org.codehaus.groovy.groovydoc.GroovyDocErrorReporter

  `printError, printNotice, printWarning`

- ## Method Details

  - ### classNamed

    GroovyClassDoc classNamed(GroovyClassDoc groovyClassDoc, String name)
    Resolves a class name from the perspective of another documented class.
    Parameters:
      `groovyClassDoc` - the class providing the lookup context
      `name` - the class name to resolve
    Returns:
      the matching class documentation, or `null` if it cannot be resolved

  - ### classes

    GroovyClassDoc[] classes()
    Returns all classes known to this documentation run.
    Returns:
      the discovered classes

  - ### options

    String[][] options()
    Returns the effective tool options associated with this documentation run.
    Returns:
      the configured options

  - ### packageNamed

    GroovyPackageDoc packageNamed(String arg0)
    Resolves a package by name.
    Parameters:
      `arg0` - the package name to resolve
    Returns:
      the matching package documentation, or `null` if none exists

  - ### specifiedClasses

    GroovyClassDoc[] specifiedClasses()
    Returns the classes explicitly specified as documentation targets.
    Returns:
      the specified classes

  - ### specifiedPackages

    GroovyPackageDoc[] specifiedPackages()
    Returns the packages explicitly specified as documentation targets.
    Returns:
      the specified packages

  - ### getVisibleClasses

    Map<String,GroovyClassDoc> getVisibleClasses(List importedClassesAndPackages)
    Returns the classes visible from a set of imports.
    Parameters:
      `importedClassesAndPackages` - the imported classes and packages to evaluate
    Returns:
      a map of visible class names to class documentation

  - ### getResolvedClasses

    Map<String,GroovyClassDoc> getResolvedClasses()
    Returns the classes that have already been resolved for the current documentation run.
    Returns:
      a map of resolved class names to class documentation